/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.enterprise.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.enterprise.feign.IDeptClient;
import org.springblade.enterprise.service.IDeptService;
import org.springblade.enterprise.service.IProjectService;
import org.springblade.enterprise.service.IStaffService;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.enterprise.entity.Enterprise;
import org.springblade.enterprise.vo.EnterpriseVO;
import org.springblade.enterprise.wrapper.EnterpriseWrapper;
import org.springblade.enterprise.service.IEnterpriseService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/enterprise")
@Api(value = "", tags = "接口")
public class EnterpriseController extends BladeController {

	private final IEnterpriseService enterpriseService;
	private IOrgPositionClient orgPositionClient;
	private IDeptClient deptClient;
	private final IResidentialClient residentialClient;
	private final IDeptService deptService;
	private final IStaffService staffService;
	private final IProjectService projectService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入enterprise")
	public R<EnterpriseVO> detail(Enterprise enterprise) {
		Enterprise detail = enterpriseService.getOne(Condition.getQueryWrapper(enterprise));
		return R.data(EnterpriseWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入enterprise")
	public R<IPage<EnterpriseVO>> list(@RequestParam Map<String,Object> enterprise, Query query, BladeUser bladeUser) {
		String deptId = bladeUser.getDeptId();
		String[] deptIds = deptId.split(",");
		LambdaQueryWrapper<Enterprise> wrapper = Condition.getQueryWrapper(enterprise,Enterprise.class).lambda();
		wrapper.orderByDesc(Enterprise::getCreateTime);
		IPage<Enterprise> pages = enterpriseService.page(Condition.getPage(query), wrapper);
		return R.data(EnterpriseWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入enterprise")
	public R<IPage<EnterpriseVO>> page(EnterpriseVO enterprise, Query query) {
		IPage<EnterpriseVO> pages = enterpriseService.selectEnterprisePage(Condition.getPage(query), enterprise);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入enterprise")
	public R save(@Valid @RequestBody Enterprise enterprise) {
		return R.status(enterpriseService.save(enterprise));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入enterprise")
	public R update(@Valid @RequestBody Enterprise enterprise) {
		return R.status(enterpriseService.updateById(enterprise));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入enterprise")
	public R submit(@Valid @RequestBody Enterprise enterprise) {
		Long residentialId = enterprise.getResidentialId();
		Residential residential = residentialClient.getById(residentialId);
		Assert.notNull(residential,"小区/区域不存在");
		enterprise.setAgencyId(residential.getAgencyId());
		enterprise.setOrgPosition(residential.getOrgPosition());
		if(enterpriseService.saveOrUpdate(enterprise)){
			enterprise.setOrgPosition(enterprise.getOrgPosition()+"/"+enterprise.getId());
		}
		return R.status(enterpriseService.updateById(enterprise));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		List<Long> list = Func.toLongList(ids);
		for(Long id: list){
			Integer staffCount = staffService.getCountByEnterpriseId(id);
			Integer deptCount = deptService.getCountByEnterpriseId(id);
			Integer projectCount = projectService.getCountByEnterpriseId(id);
			boolean delete = staffCount == 0 && deptCount == 0 && projectCount == 0;
			Assert.isTrue(delete, "请先删除企业下的员工、部门和项目");
		}
		return R.status(enterpriseService.deleteLogic(list));
	}


}
